﻿Imports Windows.UI
Imports Windows.Networking.Sockets
Imports Windows.Storage.Streams
Imports System.Runtime.Serialization.Json
Imports System.Threading
Imports Windows.Data.Json
Imports Newtonsoft.Json.Linq
Imports Newtonsoft.Json

Public NotInheritable Class MainPage
    Inherits Page

    Private Client As MessageWebSocket
    Private messageWebSocket As MessageWebSocket
    Private xmldoc As XElement
    Private myPointables As IEnumerable(Of System.Xml.Linq.XElement)
    Private myPointableCount As Integer
    Private Rnd As Random
    Private messageText As String
    Private flag As Boolean = False
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        AddHandler CompositionTarget.Rendering, AddressOf Me.CompositionTarget_Rendering
        DataShow()
    End Sub

    Private Sub DataShow()
        Rnd = New Random
        Dim myRnd = Rnd.Next(1, 6)
        sourceTextBox.Text = myRnd.ToString
    End Sub


    Private Async Sub CompositionTarget_Rendering(sender As Object, e As Object)
        Dim connecting As Boolean = True
        Try
            If Client Is Nothing = True Then
                Client = New MessageWebSocket
                AddHandler Client.MessageReceived, AddressOf Client_MessageReceived
                AddHandler Client.Closed, AddressOf Client_Closed
                Client.Control.MessageType = SocketMessageType.Utf8
                Await Client.ConnectAsync(New Uri("ws://127.0.0.1:6437/"))
                connecting = False
            End If
        Catch
            If connecting = False AndAlso Client Is Nothing = False Then
                Client.Dispose()
                Client = Nothing
            End If
        End Try
    End Sub


    Private Sub Client_MessageReceived(sender As MessageWebSocket, e As MessageWebSocketMessageReceivedEventArgs)

        Try
            Using reader As DataReader = e.GetDataReader
                reader.UnicodeEncoding = UnicodeEncoding.Utf8
                Dim read As String = reader.ReadString(reader.UnconsumedBufferLength)
                MarshalText(OutPutField, read & vbCrLf)
            End Using
        Catch
            Exit Sub
        End Try
    End Sub

    Private Sub MarshalText(output As TextBox, value As String)

        Dim ignore = output.Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, Sub()
                                                                                                   Try
                                                                                                       output.Text = value

                                                                                                       Dim myNode As XNode = JsonConvert.DeserializeXNode(output.Text, "Leap")
                                                                                                       xmldoc = XElement.Parse(myNode.ToString)
                                                                                                       myPointables = From c In xmldoc.Descendants("pointables") Select c
                                                                                                       myPointableCount = myPointables.Count
                                                                                                       resultTextBox.Text = myPointableCount
                                                                                                       If resultTextBox.Text <> 0 Then
                                                                                                           flag = True
                                                                                                           If sourceTextBox.Text.Equals(resultTextBox.Text) Then
                                                                                                               messageTextBlock.Foreground = New SolidColorBrush(Colors.Red)
                                                                                                               messageText = "私は" & sourceTextBox.Text & "の数字を思っていました。すごい！正解です。"

                                                                                                           Else
                                                                                                               messageTextBlock.Foreground = New SolidColorBrush(Colors.Gray)
                                                                                                               messageText = "私は" & sourceTextBox.Text & "の数字を思っていました。残念！不正解です。"

                                                                                                           End If
                                                                                                           messageTextBlock.Text = messageText

                                                                                                       ElseIf resultTextBox.Text = 0 AndAlso flag = True Then
                                                                                                           messageTextBlock.Text = String.Empty
                                                                                                           DataShow()
                                                                                                           flag = False
                                                                                                           Exit Sub
                                                                                                       End If

                                                                                                   Catch
                                                                                                       Exit Sub
                                                                                                   End Try
                                                                                               End Sub)

    End Sub

    Private Sub Client_Closed(sender As IWebSocket, e As WebSocketClosedEventArgs)
        If Client Is Nothing = False Then
            Client.Dispose()
        End If
    End Sub
End Class


